"use strict";

exports.__esModule = true;
exports.default = usePromise;

var _rax = require("rax");

function usePromise(promise) {
  var _useState = (0, _rax.useState)(null),
      error = _useState[0],
      setError = _useState[1];

  var _useState2 = (0, _rax.useState)(null),
      result = _useState2[0],
      setResult = _useState2[1];

  (0, _rax.useEffect)(function () {
    var canceled = false;
    promise.then(function (r) {
      if (!canceled) {
        setResult(r);
      }
    }).catch(function (e) {
      if (!canceled) {
        setError(e);
      }
    });
    return function () {
      canceled = true;
    };
  }, [promise]);
  return [result, error];
}